#!/usr/local/bin/perl

print "HTTP/1.0 200 OK\n";
print "Content-type: text/html\n\n";

### written by Vishal Majithia ###
# vishal@vishal.cc or vmajithia@salud.unm.edu or vm1757@unm.edu
# www.vishal.cc
#
#######################################################################
# User configurable variables start here
#
$formname = "http://SOMESERVER.com/scripts/upDown.pl";
$html_page = http://SOMESERVER.com/miscellaneous/upDown.html";
$sequence_size = 500;
$max_start_allowed = 10000;
$repeat_color='#FFCCAA';
#
#######################################################################

parse_form;

if (invalid($start_number))
  {
  get_new_start_number;
  die;
  }
else
  {
  gen_sequence;
  print_output;
  }

## END OF PROGRAM


## Start of subroutines

# simply parses the input, only one field in this case: $start_number.
sub parse_form()
  {
  use CGI;
  $query = new CGI;
  $start_number = $query->param('start_number');
  }

# verifies input is:
# 1. numeric only (no commas, spaces, letters, etc. and NO negative sign)
# 2. <= maximum allowed val. First, the input length is limited in html form field.
#    Second, it will make the output very messy if every number is twenty digits long.
sub invalid($)
  {
  my $s = $_[0];
  if ($s =~ /\D/ || $s >= $max_start_allowed)
    { return 1; }
  return 0;
  }

# bad input was entered, so get input again, along with message informing user of what
# constitutes valid input.
sub get_new_start_number()
  {
  print <<_G_N_S_N;
<html>
<head>
<meta name="AUTHOR" content="Vishal Majithia">
<meta name="GENERATOR" content="Microsoft FrontPage 3.0">
<title>Up Down Sequence Generator</title>
</head>
<body>
<form METHOD="POST" ACTION="$formname">
  <div align="center"><center>
  <h2>Up Down Sequence Generator</h2><br><br>
  <B>Note:</B> Input must be only numeric, with a value<br>
  between 0 and $max_start_allowed<br><br>
  </center></div><div align="center"><center><p>
  Starting number: <input TYPE="text" size="6" maxlength="6"></p><p>
  <input TYPE="submit" VALUE="Generate Sequence"></p>
  </center></div>
</form>
<BR><BR><BR><BR>
<p><a href="http://www.vishal.cc">www.vishal.cc</a><br>
<br>
<a href="mailto:vishal@vishal.cc">vishal@vishal.cc</a><br>
</p>
</body>
</html>
_G_N_S_N
  }

# This function will actually generate the sequence, storing it in an array, as well
# as looking for repeats. It will set a flag for a repeat. This array is global
# since the output function needs to access the same array.
sub gen_sequence()
  {
  @up_down_sequence = ();
  my %up_down_location = ();
  my $current_position = 0; # loop counter and array index.
  my $current_val = $start_number; #initialize 1st up-down number.
  my $next_val; # holds next val in sequence.
  $first_repeat = -1; # position, flag, global used by output function.
  while (scalar(@up_down_sequence) < $sequence_size)
    {
    if ($current_val % 2 == 1) # x(k) is odd
	{ $next_val = 3 * $current_val + 1; }
    else # x(k) is even
	{ $next_val = $current_val / 2; }

    # Got number, now check for repeat, log its position...
    if (! exists($up_down_location{$next_val})) # new value in sequence.
	{ $up_down_location{$next_val} = $current_position; }
    elsif ($first_repeat == -1) # first repeat, flag this position.
	{ $first_repeat = $current_position; }
    else # not first repeat, but already in list, do nothing.
	{}

    # prepare for next loop iteration here.
    $current_val = $next_val;
    $current_position++ ;
    }
  }

# This function prints output to the screen, in a table format. From the point
# of repeating sequence, the numbers change color.
sub print_output()
  {
  print <<_OUT_1;
<html>
<head>
<meta name="AUTHOR" content="Vishal Majithia">
<meta name="GENERATOR" content="Microsoft FrontPage 3.0">
<title>Up Down Sequence Generator</title>
</head>
<body>
<center>
<h2>Up Down Sequence<br>
starting with $start_number</h2>
<br>
<h4>The sequence goes from left to right in each row, then down to the<br>
beginning of the next row. The sequence length is $sequence_size. The sequence<br>
changes color at the point at which cycling (repetition) begins.</h4>
<br>
<table>
<tr>
_OUT_1
  for (my $count = 0; $count < $sequence_size; $count++ )
    {
    if ($count % 10 == 0 && $count != 0)
	{ print "</tr><tr>"; }
    print "<td>";
    if ($count >= $first_repeat)
	{ print "<font color=\"$repeat_color\">"; }
    print "$up_down_sequence[$count]";
    if ($count >= $first_repeat)
	{ print "</font>"; }
    print "</td>";
    if ($count % 10 == 0 && $count != 0)
	{ print "</tr><tr>"; }
    }
  print <<_OUT_2;
</table>
<BR><BR>
<a href="$html_page">Click here to run the sequence with a new number.</a>
<BR><BR>
<p><a href="http://www.vishal.cc">www.vishal.cc</a><br>
<br>
<a href="mailto:vishal@vishal.cc">vishal@vishal.cc</a><br>
</p>
</center>
</body>
</html>
_OUT_2
  }
